<template>
  <div>
    <div>
<CModal
      title="Modal title"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Customer Ageing Mapping</h5>
   
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="15"
      pagination
      hover
      striped
      border
      sorter
     >
 
<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectCustomerAgeing(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectCustomerAgeing(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectCustomerAgeing(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New Customer Ageing Mapping</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Enter Mapping Details</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">


<div class="form-group">
  <label for="customer_Name">Customer </label>
 <select class="form-control"   v-model="newCustomer.customer_Id" >
    <option value="" selected disabled>Select Customer</option>
    <option v-for="item in customeritems" :value="item.customer_Id" :key="item.customer_Id">{{ item.customer_Name }}</option>
  </select>
</div>

<div class="form-group">
    <label for="batch_Type_Id">Ageing in Months</label>
 <select class="form-control"   v-model="newCustomer.ageing_Id" >
    <option value="" selected disabled>Select Ageing</option>
    <option v-for="item in ageingitems" :value="item.ageing_Id" :key="item.ageing_Id">{{ item.ageing_Months }}</option>
  </select>
</div>


<div class="form-group" >
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;AddMapping();" > Add New Customer Ageing Mapping </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

 

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Customer Ageing Mapping</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
    <label for="customer_Id">Id</label>
<input type="text" label ="Id" name="cust_Ageing_Id" readonly class="form-control form-control-lg" placeholder= "Customer Id" v-model="CurrentCustomer.cust_Ageing_Id">
</div>

<div class="form-group">
    <label for="customer_Name">Name</label>
<input type="text" name="customer_Name" readonly class="form-control form-control-lg" placeholder="Customer Name" v-model="CurrentCustomer.customerName">
</div>

<div class="form-group">
    <label for="ageingMonths">Ageing Months </label>
<input type="text" name="ageingMonths" readonly class="form-control form-control-lg" placeholder="ageingMonths"  v-model="CurrentCustomer.ageingMonths">
</div>
<div class="form-group">
    <label for="entryDate">Entry Date</label>
<input type="text" name="entryDate" readonly class="form-control form-control-lg" placeholder="entryDate"  v-model="CurrentCustomer.entryDate">
</div>


<div class="form-group">
  
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>


  

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Customer</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group">
    <label for="customer_Id">Id</label>
<input type="text" label ="Id" name="cust_Ageing_Id" readonly class="form-control form-control-lg" placeholder= "Customer Id" v-model="CurrentCustomer.cust_Ageing_Id">
</div>

<div class="form-group">
  <label for="customer_Name">Customer </label>
 <select class="form-control"   v-model="CurrentCustomer.customer_Id" >
    <option value="" selected disabled>Select Customer</option>
    <option v-for="item in customeritems" :value="item.customer_Id" :key="item.customer_Id">{{ item.customer_Name }}</option>
  </select>
</div>

<div class="form-group">
    <label for="batch_Type_Id">Ageing in Months</label>
 <select class="form-control"   v-model="CurrentCustomer.ageing_Id" >
    <option value="" selected disabled>Select Ageing</option>
    <option v-for="item in ageingitems" :value="item.ageing_Id" :key="item.ageing_Id">{{ item.ageing_Months }}</option>
  </select>
</div>



<div class="form-group">
<button type="button" class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateMapping();" > Update Customer Mapping</button>
</div>
</form>

</div>
</div>
</div>
</div>


<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Customer/Ageing Mapping</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Mapping ? </h4>
<h5> You are deleting {{ this.CurrentCustomer.ageing_Id +' || '+ this.CurrentCustomer.ageing_Months }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteMapping();getAllCustomerAgeingMappingDetails(); "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const apiurl =  'FGS_FIFO_Cust_Ageing_Mapping/'
const items = [
    { key: 'cust_Ageing_Id', _style:'min-width:100px;' },
  { key: 'customerName', _style:'min-width:200px' },
 { key: 'ageingMonths', _style:'min-width:50px;' },
  { key: 'entryDate',    _style: 'width:1%',  },
 
 ]    
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
  data ()
  {
     return {
     items: items.map((item,) => { return {...item,}}),
     fields: [
        { key: 'cust_Ageing_Id', label: 'Cust-Ageing-Id', },
        { key: 'customerName' , label: 'Customer Name',},
        { key: 'ageingMonths', label: 'Ageing Months',  },
        { key: 'show_details',  label: '',  _style: 'width:30%' , }
      
              
      ],
  customeritems:"",
  materialtypeitems:"",
  ageingitems:"",
  details: [],
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentCustomer:{customer_Id:0,ageing_Id:"",entryDate:new Date(), ageing_Status : 1},
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newCustomer: {customer_Id:0,ageing_Id:"", entryDate:new Date(), ageing_Status : 1}, }
  },



  mounted()
  {
  this.getAllCustomerAgeingMappingDetails();
   this.getAllCustomerDetails();
   this.getAllAgeingDetails();
  },

  methods:
  {
  
   getAllCustomerAgeingMappingDetails: function()
   {
    
  Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.ageing_Status == 1)
       }
    });
   },


   getAllCustomerDetails: function()
   {
   
   Vue.axios.get(this.$url +'FGS_FIFO_Customer_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        
        this.customeritems = response.data.filter(x => x.cust_Status == 1)
       }
    });
   },

   getAllAgeingDetails: function()
   {
   Vue.axios.get(this.$url+'FGS_FIFO_Ageing_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
         console.log(response.data)
        this.ageingitems =response.data.filter(x => x.status == 1)
        
       }
    });
   },
  AddMapping()
  {
  
    if(this.items.find(x => x.customer_Id == this.newCustomer.customer_Id && x.ageing_Status == this.newCustomer.ageing_Status))
    {
    
        this.SuccessMsg ="Customer Name " + this.newCustomer.customer_Name +" already exist."
        this.smallModal = true;
    }
    else
    {
     
   Vue.axios.post(this.$url + apiurl,this.newCustomer).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        
        this.smallModal = true;
        this.getAllAgeingDetails();
        location.reload();
        this.SuccessMsg ="Record added Successfully.."
       }
    })
    }
   },

  UpdateMapping()
  {
   
    Vue.axios.put(this.$url + apiurl +this.CurrentCustomer.cust_Ageing_Id,this.CurrentCustomer,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        
         this.getAllCustomerAgeingMappingDetails();
          this.SuccessMsg ="Records Updated Successfully.."
       }
    })
   },

  deleteMapping()
    {
       
      var customer_Id = this.CurrentCustomer.cust_Ageing_Id;
        axios({   method: 'delete',
           url: this.$url + apiurl + customer_Id
    });   
      
        this.getAllCustomerDetails();
          this.SuccessMsg="Customer Status of "+ customer_Id +" Changed to Inactive Succesfully"
    },
      
  SelectCustomerAgeing(Customer)
    {
     
     this.CurrentCustomer=Customer;
    },



  }
}
</script>

<style scoped>
#overlay{
  position:absolute;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>